// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	strfmt "github.com/go-openapi/strfmt"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/swag"
)

// JwtToken JwtToken - returned after user login
// swagger:model JwtToken
type JwtToken struct {

	// status
	Status string `json:"status,omitempty"`

	// token
	Token string `json:"token,omitempty"`

	// user details
	UserDetails *User `json:"user_details,omitempty"`
}

// Validate validates this jwt token
func (m *JwtToken) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateUserDetails(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *JwtToken) validateUserDetails(formats strfmt.Registry) error {

	if swag.IsZero(m.UserDetails) { // not required
		return nil
	}

	if m.UserDetails != nil {
		if err := m.UserDetails.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("user_details")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *JwtToken) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *JwtToken) UnmarshalBinary(b []byte) error {
	var res JwtToken
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
